/*
 * PreparandoApplet.java
 * Verso: 2004-03-16
 * Autor: Celmar Guimares da Silva
-------------------------------------------------------------------------------

    TelEduc - Ambiente de Ensino-Aprendizagem a Distncia
    Copyright (C) 2003  NIED - Unicamp

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    You could contact us through the following addresses:

    Nied - Ncleo de Informtica Aplicada  Educao
    Unicamp - Universidade Estadual de Campinas
    Cidade Universitria "Zeferino Vaz"
    Bloco V da Reitoria - 2o. Piso
    CEP:13083-970 Campinas - SP - Brasil

    http://www.nied.unicamp.br
    nied@unicamp.br

------------------------------------------------------------------------------
 */

package applet;

/** Cria uma barra de progresso contendo frase introdutria e indicador de fase do processo.
 * @author Celmar
 */
public class PreparandoApplet extends javax.swing.JPanel {
   
    /** Frase de introduo.
     */    
    private javax.swing.JLabel jLabel1;
    /** Nome da fase atual do processo.
     */    
    private javax.swing.JLabel nomeDaFase;
    /** Barra de progresso.
     */    
    private javax.swing.JProgressBar jProgressBar1;    
    
    /** Construtor da classe PreparandoApplet.
     */
    public PreparandoApplet() {
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {
        jProgressBar1 = new javax.swing.JProgressBar();
        jLabel1 = new javax.swing.JLabel();
        nomeDaFase = new javax.swing.JLabel();

        setLayout(new java.awt.BorderLayout());

        add(jProgressBar1,java.awt.BorderLayout.CENTER);

        jLabel1.setFont(new java.awt.Font("Arial", 1, 12));
        jLabel1.setText("");
        jLabel1.setMaximumSize(new java.awt.Dimension(395, 50));
        jLabel1.setMinimumSize(new java.awt.Dimension(395, 50));
        jLabel1.setPreferredSize(new java.awt.Dimension(395, 50));
        add(jLabel1, java.awt.BorderLayout.NORTH);

        nomeDaFase.setFont(new java.awt.Font("Arial", 0, 12));
        nomeDaFase.setText("");
        add(nomeDaFase, java.awt.BorderLayout.SOUTH);
    }
    
    /** Altera a frase de introduo, acima da barra de progresso.
     * @param frase Nova frase de introduo.
     */    
    public void ajustarFraseDeIntroducao(String frase) {
        jLabel1.setText(frase);        
    }
    
    /** Altera o nome da fase atual, abaixo da barra de progresso.
     * @param nome Nome da nova fase.
     */    
    public void ajustarNomeDaFase(String nome) {
        nomeDaFase.setText(nome);        
    }
    
    /** Ajusta o valor da barra de progresso.
     * @param valor Valor da barra de progresso. Deve estar entre 0 e 100.
     */    
    public void ajustarValor(int valor) {
        jProgressBar1.setValue(valor);
    }

    /** Obtm valor de progresso.
     * @return Valor da barra de progresso.
     */
    public int obterValor() {
        return(jProgressBar1.getValue());
    }
    
}
