/*
 * GerenciadorXGMML.java
 * Verso: 2004-03-16
 * Autor: Celmar Guimares da Silva
 */

package grafo;

import java.io.*;

/** Estipula mtodos de leitura e escrita de arquivos XGMML.
 */
public interface GerenciadorXGMML {
    
    // Constantes de tipos de ns de um documento DOM.
    /** N DOM do tipo atributo */    
    final int nodeTypeAttr = 2;
    /** N DOM do tipo documento. */    
    final int nodeTypeDocument = 9;
    /** N DOM do tipo elemento. */    
    final int nodeTypeElement = 1;
    /** N DOM do tipo texto. */    
    final int nodeTypeText = 3;

    
    /** Retorna tags de atributos para gravao de arquivo XGMML.
     * @param o Instncia de FileWriter (arquivo) na qual os atributos sero 
     * escritos.
     * @throws IOException Ocorre exceo se houver problemas com o arquivo.
     */
    public void escreverAtributosXGMML(FileWriter o) throws IOException;
    
    /** L tags de atributos XGMML de um elemento, ajustando suas propriedades
     * de acordo com esses atributos.
     * @param raiz N DOM do qual as tags &lt;ATT&gt; sero lidas
     */
    public void lerAtributosXGMML(org.w3c.dom.Node raiz);
    
}
