/*
 * StringInfo.java
 * Verso: 2004-08-26
 * Autores: Celmar Guimares da Silva e Petr Stukjunger
 */

package grafo;

import javax.swing.*;
import java.io.*;

/** Classe que implementa Info para criar objetos que armazenem informao 
 * textual a ser usada por um n ou uma aresta do grafo.
 */
public class StringInfo implements Info 
{
    
    /** Texto que esta classe armazena.
     */
    public String texto="";

    /** Cria uma nova instncia de StringInfo. */
    public StringInfo() {
        texto = "";
    }
    
    /** Cria uma nova instncia de StringInfo.
     * @param texto Informao textual (String) a ser armazenada.
     */
    public StringInfo(String texto) {
        this.texto = texto;
    }
    
//    /** Informa se um objeto especificado  igual ao objeto em questo.
//     * Dois objetos StringInfo so iguais se apresentam o mesmo valor da
//     * propriedade texto.
//     * @param obj Objeto a ser comparado.
//     * @return True se o objeto for igual, false caso contrrio.
//     */
//    public boolean equals(Object obj) {
//        if (obj.getClass() != this.getClass()) return false;
//        return ((StringInfo)obj).texto.equals(texto);
//    }
    
    /** Retorna string que representa a informao.
     * @return Retorna string que represente a informao.
     */
    public String toString() {
        return texto;
    }
    
    /** Retorna representao visual de informao.
     * @return Retorna um JTextPane contendo a informao armazenada por este objeto.
     */
    public JComponent retornarInformacao() {
        JTextPane pane = new JTextPane();
        pane.setEditable(false);
        pane.setText(texto);
        return pane;
    }
    
}

