/*
 * Info.java
 * Verso: 2004-07-04
 * Autor: Celmar Guimares da Silva
 */

package grafo.xgmml;

/**
 * Classe abstrata para leitura e escrita de tags XGMML relativas a uma informao.
 */
public interface Info extends Io  {
    
    /**
     * L tags de atributos XGMML de um n DOM e ajusta as propriedades de um objeto
     * grafo.Info de acordo com esses atributos.
     * @param raiz N DOM contendo as tags a serem lidas.
     * @param obj Objeto grafo.Info cujos atributos sero ajustados.
     */
    //public Info() {
    //}
    
    public void lerAtributosXGMML(org.w3c.dom.Node raiz, Object obj);
    
    /** Escreve as tags XGMML que representam uma informao definida em obj.
     * @param o Instncia de FileWriter (arquivo) na qual as tags sero 
     * escritas.
     * @param obj Objeto a ser descrito pelas tags.
     * @throws IOException Ocorre exceo se houver problemas com o arquivo.
     */  
    public void escreverAtributosXGMML(java.io.FileWriter o, Object obj) throws java.io.IOException;
    
}
