/*
 * Io.java
 * Verso: 2004-07-04
 * Autor: Celmar Guimares da Silva
 */

package grafo.xgmml;

import java.io.*;

/** Estipula mtodos de leitura e escrita de arquivos XGMML.
 */
public interface Io {
    
    /** Escreve as tags XGMML que representam o objeto obj.
     * @param o Instncia de FileWriter (arquivo) na qual as tags sero 
     * escritas.
     * @param obj Objeto a ser descrito pelas tags.
     * @throws IOException Ocorre exceo se houver problemas com o arquivo.
     */
    public void escreverAtributosXGMML(FileWriter o, Object obj) throws IOException;
    
    /**
     * L tags de atributos XGMML de um n DOM e ajusta as propriedades do objeto
     * obj de acordo com esses atributos.
     * @param raiz N DOM do qual as tags sero lidas.
     * @param obj Objeto cujas caracteristicas sero estabelecidas pelas tags.
     */
    public void lerAtributosXGMML(org.w3c.dom.Node raiz, Object obj);
    
}
