/*
 * IoGrafo.java
 * Verso: 2004-07-04
 * Autor: Celmar Guimares da Silva
 */

package grafo.xgmml;

/**
 * Interface que define mtodos de leitura e escrita de grafos.
 */
public interface IoGrafo {
    
    /**
     * Escreve as tags XGMML que representam um grafo.
     * @param g Grafo cujas propriedades sero descritas.
     * @param o Instncia de FileWriter (arquivo) na qual os atributos sero
     * escritos.
     * @throws IOException Ocorre exceo se houver problemas com o arquivo.
     */  
    public void escreverXGMML(java.io.FileWriter o, grafo.Grafo g) throws java.io.IOException;
    
    /**
     * L um arquivo XGMML especificado e armazena o grafo por ele descrito.
     * @param g Grafo cujo contedo ser definido.
     * @param arquivo Arquivo XGMML
     * @throws IOException Ocorre quando o arquivo informado no existir.
     */      
    public void lerXGMML(java.io.File arquivo, grafo.Grafo g) throws java.io.IOException;
    
}
